<?php
/*
Plugin Name: WP jScrollPane
Plugin URI: http://www.alltechservices-ia.com/downloads/
Description: 
Version: 1.2
Author: Jacob [cornfeed]
Author URI: http://www.alltechservices-ia.com/
License: GPL/GNU
*/

// Check if the class has been defined before
if (!class_exists('wp_jscrollpane')) {
	// If not, define the class
	class wp_jscrollpane {
		// An array needed to be defined for a foreach loop later
		var $scrolltemp = array();
		
		function __construct() {
			// Check if we are in the dashboard
			if ( is_admin() ) {
				add_action('admin_init', array($this, 'wpjsp_admin_init'));
				add_action('admin_menu', array($this, 'wpjsp_admin_menu'));
				register_activation_hook(__FILE__, array(&$this, 'initialize_defaults'));
				// Check to see if we are updating WP jScrollPane
				if ( isset($_POST['wpjsp']) && $_POST['wpjsp']=='true' ) {
					foreach($_POST as $key => $value) {
						preg_match('/^wpjsp-.*/',$key,$wpjsp_post);
						// If there are any POST values relavent to WP jScrollPane, let's parse them
						if ( isset($wpjsp_post[0]) ) {
							foreach($wpjsp_post as $opt_name) {
								preg_match('/^wpjsp-class-./',$opt_name,$class_name);
								if ( isset($class_name[0]) && !($_POST[$class_name[0]]=='') ) {
									$this->cnames .= $_POST[$class_name[0]].',';
									$this->check = $_POST[$class_name[0]];
								} elseif ( isset($class_name[0]) && $_POST[$class_name[0]]=='' ) {unset($this->check);}
								preg_match('/^wpjsp-hwidth-./',$opt_name,$hwidth);
								if ( isset($this->check) && isset($hwidth[0]) && !($_POST[$hwidth[0]]=='0') ) {$this->hwidth .= $_POST[$hwidth[0]].',';}
								preg_match('/^wpjsp-vwidth-./',$opt_name,$vwidth);
								if ( isset($this->check) && isset($vwidth[0]) && !($_POST[$vwidth[0]]=='0') ) {$this->vwidth .= $_POST[$vwidth[0]].',';}
								preg_match('/^wpjsp-hcap-./',$opt_name,$hcap);
								if ( isset($this->check) && isset($hcap[0]) && !($_POST[$hcap[0]]=='0') ) {$this->hcap .= $_POST[$hcap[0]].',';}
								preg_match('/^wpjsp-vcap-./',$opt_name,$vcap);
								if ( isset($this->check) && isset($vcap[0]) && !($_POST[$vcap[0]]=='0') ) {$this->vcap .= $_POST[$vcap[0]].',';}
								preg_match('/^wpjsp-arrows-./',$opt_name,$arrow_color);
								if ( isset($this->check) && isset($arrow_color[0]) ) {$this->acolor .= $_POST[$arrow_color[0]].',';}
								preg_match('/^wpjsp-button-./',$opt_name,$scroll_bttn);
								if ( isset($this->check) && isset($scroll_bttn[0]) ) {$this->scrollbttn .= $_POST[$scroll_bttn[0]].',';}
								preg_match('/^wpjsp-pane-./',$opt_name,$scroll_pane);
								if ( isset($this->check) && isset($scroll_pane[0]) ) {$this->scrollpane .= $_POST[$scroll_pane[0]].',';}
								preg_match('/^wpjsp-cap-./',$opt_name,$cap);
								if ( isset($this->check) && isset($cap[0]) ) {$this->cap .= $_POST[$cap[0]].',';}
								preg_match('/^wpjsp-position-./',$opt_name,$arrow_pos);
								if ( isset($this->check) && isset($arrow_pos[0]) ) {$this->aposition .= $_POST[$arrow_pos[0]].',';}
								preg_match('/^wpjsp-hgutter-./',$opt_name,$horizgutter);
								if ( isset($this->check) && isset($horizgutter[0]) && !($_POST[$horizgutter[0]]=='0') ) {$this->hgutter .= $_POST[$horizgutter[0]].',';}
								preg_match('/^wpjsp-vgutter-./',$opt_name,$vertgutter);
								if ( isset($this->check) && isset($vertgutter[0]) && !($_POST[$vertgutter[0]]=='0') ) {$this->vgutter .= $_POST[$vertgutter[0]].',';}
								preg_match('/^wpjsp-left-./',$opt_name,$scrleft);
								if ( isset($this->check) && isset($scrleft[0]) ) {
									$i = intval( substr($scrleft[0],-1) );
									$this->scrolltemp[$i-1] = $scrleft[0];
								}
								preg_match('/^wpjsp-wheel/',$opt_name,$wheel);
								if ( isset($wheel[0]) ) {$this->wheel = $_POST[$wheel[0]];}
							}
						}
					}
					// Last step for the 'move scrollbar to the left' checkboxes
					for ($i=0;$i<count(explode(',',rtrim($this->cnames, ',')));$i++) {
						if ( isset($this->scrolltemp[$i]) ) {
							$this->leftscroll .= $this->scrolltemp[$i].',';
						} else {$this->leftscroll .= ',';}
					}
					update_option('wpjsp-class', rtrim($this->cnames, ',') );
					update_option('wpjsp-hwidth', rtrim($this->hwidth, ',') );
					update_option('wpjsp-vwidth', rtrim($this->vwidth, ',') );
					update_option('wpjsp-hgutter', rtrim($this->hgutter, ',') );
					update_option('wpjsp-vgutter', rtrim($this->vgutter, ',') );
					update_option('wpjsp-hcap', rtrim($this->hcap, ',') );
					update_option('wpjsp-vcap', rtrim($this->vcap, ',') );
					update_option('wpjsp-arrows', rtrim($this->acolor, ',') );
					update_option('wpjsp-button', rtrim($this->scrollbttn, ',') );
					update_option('wpjsp-pane', rtrim($this->scrollpane, ',') );
					update_option('wpjsp-cap', rtrim($this->cap, ',') );
					update_option('wpjsp-left', rtrim($this->leftscroll, ',') );
					update_option('wpjsp-wheel', $this->wheel);
					update_option('wpjsp-position', rtrim($this->aposition, ',') );
					
					// Now use these values to write our relavent css & js
					$this->classes = explode(',', get_option('wpjsp-class') );
					$this->arrows = explode(',', get_option('wpjsp-arrows') );
					$this->hgutt = explode(',', get_option('wpjsp-hgutter') );
					$this->vgutt = explode(',', get_option('wpjsp-vgutter') );
					$this->position = explode(',', get_option('wpjsp-position') );
					$this->button = explode(',', get_option('wpjsp-button') );
					$this->pane = explode(',', get_option('wpjsp-pane') );
					$this->left = explode(',', get_option('wpjsp-left') );
					$this->hwidth = explode(',', get_option('wpjsp-hwidth') );
					$this->vwidth = explode(',', get_option('wpjsp-vwidth') );
					$this->cap = explode(',', get_option('wpjsp-cap') );
					$this->hcap = explode(',', get_option('wpjsp-hcap') );
					$this->vcap = explode(',', get_option('wpjsp-vcap') );
					if ( isset($this->classlst[0]) && !($this->classlst[0]=='') ) {
						$this->js = 'var $j = jQuery.noConflict();$j(function(){jQuery(document).ready(function($){';}
					foreach($this->classes as $key=>$class_name) {
						if ( isset($this->arrows[$key]) && !($this->arrows[$key]=='') ) {
							$opts_js .= 'showArrows: true,';} else {$opts_js .= '';}
						if ( isset($this->hgutt[$key]) && !($this->hgutt[$key]=='') ) {
							$opts_js .= 'horizontalGutter: '.$this->hgutt[$key].',';} else {$opts_js .= '';}
						if ( isset($this->vgutt[$key]) && !($this->vgutt[$key]=='') ) {
							$opts_js .= 'verticalGutter: '.$this->vgutt[$key].',';} else {$opts_js .= '';}
						if ( isset($this->position[$key]) && !($this->position[$key]=='') ) {
							$opts_js .= 'verticalArrowPositions: \''.$this->position[$key].'\','.'horizontalArrowPositions: \''.$this->position[$key].'\',';} else {$opts_js .= '';}
						if ( !($opts_js=='') ) {$opts_js = '{'.$opts_js.'}';}
						if ( isset($this->classes[0]) && !($this->classes[0]=='') ) {$js = '$(\''.$class_name.'\').jScrollPane('.$opts_js.');';}
						if ( isset($this->hwidth[$key]) && !($this->hwidth[$key]=='') ) {
							$css .= $class_name.' .jspHorizontalBar {height:'.$this->hwidth[$key].'px !important;}';}
						if ( isset($this->vwidth[$key]) && !($this->vwidth[$key]=='') ) {
							$css .= $class_name.' .jspVerticalBar {width:'.$this->vwidth[$key].'px !important;}';}
						if ( ( isset($this->hcap[$key]) && !($this->hcap[$key]=='') ) || ( isset($this->vcap[$key]) && !($this->vcap[$key]=='') ) && ( isset($this->cap[$key]) && !($this->cap[$key]=='') ) ) {
							$css .= $class_name.' .jspCap {display:block;background:#'.$this->cap[$key].';}';}
						if ( isset($this->hcap[$key]) && !($this->hcap[$key]=='') ) {
							$css .= $class_name.' .jspHorizontalBar .jspCap {width:'.$this->hcap[$key].'px;height:100%;}';}
						if ( isset($this->vcap[$key]) && !($this->vcap[$key]=='') ) {
							$css .= $class_name.' .jspVerticalBar .jspCap {height:'.$this->vcap[$key].'px;}';}
						if ( isset($this->arrows[$key]) && !($this->arrows[$key]=='') ) {
							$css .= $class_name.' .jspArrow {background:#'.$this->arrows[$key].';}';}
						if ( isset($this->button[$key]) && !($this->button[$key]=='') ) {
							$css .= $class_name.' .jspDrag {background:#'.$this->button[$key].' !important;}';}
						if ( isset($this->pane[$key]) && !($this->pane[$key]=='') ) {
							$css .= $class_name.' .jspTrack {background:#'.$this->pane[$key].' !important;}';}
						if ( isset($this->left[$key]) && !($this->left[$key]=='') ) {
							$css .= $class_name.' .jspVerticalBar {left:0 !important;}';}
						$this->css .= $css;$this->js .= $js;
						unset($css);unset($js);unset($opts_js);
					}
					$this->js = 'var $j = jQuery.noConflict();$j(function(){jQuery(document).ready(function($){'.$this->js.'});});';
					$file1 = fopen(plugin_dir_path(__FILE__).'js/wpjsp.js','w');
					$file2 = fopen(plugin_dir_path(__FILE__).'css/wpjsp.css','w');
					fwrite($file1,$this->js);
					fwrite($file2,$this->css);
					fclose($file1);
					fclose($file2);
				}
			}
			// If we aren't in the dashboard, load jScrollPane
			if ( !is_admin() ) {add_action('init', array($this, 'wpjsp_page_init') );}
		}
		
		function initialize_defaults() {
			add_option('wpjsp-hwidth','','','no');
			add_option('wpjsp-vwidth','','','no');
			add_option('wpjsp-hcap','','','no');
			add_option('wpjsp-vcap','','','no');
			add_option('wpjsp-cap','','','no');
			add_option('wpjsp-class','','','no');
			add_option('wpjsp-wheel','','','no');
			add_option('wpjsp-arrows','','','no');
			add_option('wpjsp-hgutter','','','no');
			add_option('wpjsp-vgutter','','','no');
			add_option('wpjsp-left','','','no');
			add_option('wpjsp-pane','','','no');
			add_option('wpjsp-button','','','no');
			add_option('wpjsp-position','','','no');
		}
		function wpjsp_page_init() {
			wp_register_script('mousewheel', plugins_url('/js/jquery.mousewheel.js',__FILE__), array('jquery') );
			wp_register_script('jscrollpane', plugins_url('/js/jquery.jscrollpane.js',__FILE__), array('jquery') );
			if ( get_option('wpjsp-wheel')=='on' ) {$arr = array('jquery','jscrollpane','mousewheel');} else {$arr = array('jquery','jscrollpane');}
			wp_register_script('wpjsp', plugins_url('/js/wpjsp.js',__FILE__), $arr );
			wp_register_style('jscrollpane', plugins_url('/css/jquery.jscrollpane.css',__FILE__) );
			wp_register_style('wpjsp', plugins_url('/css/wpjsp.css',__FILE__), array('jscrollpane') );
			wp_enqueue_style('wpjsp');
			wp_enqueue_script('wpjsp');
		}
		function wpjsp_admin_init() {
			wp_register_style('colorpicker', plugins_url('/css/jquery.colorpicker.css',__FILE__));
			wp_register_style('wpjsp-style', plugins_url('/css/admin.css',__FILE__));
			wp_deregister_script('colorpicker');
			wp_register_script('colorpicker', plugins_url('/js/jquery.colorpicker.js',__FILE__), array('jquery'));
			wp_register_script('wpjsp-script', plugins_url('/js/admin.js', __FILE__), array('jquery','colorpicker'));
		}
		function wpjsp_admin_menu() {
			$page = add_submenu_page('options-general.php', 'WP jScrollPane', 'WP jScrollPane', 'manage_options', __FILE__, array($this, 'wpjsp_options_page'));
			add_action('admin_print_styles-'.$page, array($this, 'wpjsp_admin_styles'));
			add_action('admin_print_scripts-'.$page, array($this, 'wpjsp_admin_scripts'));
		}
		function wpjsp_admin_styles() {
			wp_enqueue_style('wpjsp-style');
			wp_enqueue_style('colorpicker');
		}
		function wpjsp_admin_scripts() {
			wp_enqueue_script('wpjsp-script');
		}
		function wpjsp_options_page(){
			$this->counter = count( explode(',', get_option('wpjsp-class') ) );
			$this->classes = explode(',', get_option('wpjsp-class') );
			$this->arrows = explode(',', get_option('wpjsp-arrows') );
			$this->hgutters = explode(',', get_option('wpjsp-hgutter') );
			$this->vgutters = explode(',', get_option('wpjsp-vgutter') );
			$this->scrollleft = explode(',', get_option('wpjsp-left') );
			$this->position = explode(',', get_option('wpjsp-position') );
			$this->button = explode(',', get_option('wpjsp-button') );
			$this->pane = explode(',', get_option('wpjsp-pane') );
			$this->hwidth = explode(',', get_option('wpjsp-hwidth') );
			$this->vwidth = explode(',', get_option('wpjsp-vwidth') );
			$this->hcap = explode(',', get_option('wpjsp-hcap') );
			$this->vcap = explode(',', get_option('wpjsp-vcap') );
			$this->cap = explode(',', get_option('wpjsp-cap') );
			$this->wheel = get_option('wpjsp-wheel');
		?>
			<div class="wrap" id="wpjsp-options">
				<div id="icon-options-general" class="icon32"></div><h2>WP jScrollPane Settings</h2>
				<form method="post" action="#">
					<?php settings_fields('wpjscrollpane'); ?>
					<div id="wpjsp_scrollbars">
						<div id="wpjsp_add_scrollbars" ></div>
						<ul>
							<li><b>Identifier</b> is a CSS style identifier. For example: <b>#IDname</b> OR <b>.class-name</b> OR <b>#IDname .child-class</b></li>
							<li>H&V Widths are the widths of the scrollbars themselves</li>
							<li>H&V Gutters are essentially padding between the content and the scrollbar</li>
							<li>H&V Caps are used to shorten the size of your scrollbar</li>
							<li>Remove the Identifier and Save if you want to remove a set of scrollbars</li>
							<li style="color:red;font-size:16px;">Version 2 is ready and I need testers that are good with CSS.<br />Please get in contact with me jscrollpane@alltechservices-ia.com</li>
							</li><input type="checkbox" id="wheel" name="wpjsp-wheel" <?php if (!($this->wheel=='')) {echo 'checked="checked" ';} ?>/><label for="wheel">Make jScrollPane Mousewheel Scrollable</label></li>
						</ul>
					<?php
						for ($i = 0; $i<$this->counter; $i++) {$n = $i+1;
						?>
							<div class="wpjsp_scrollbars">
								<table>
									<tbody>
										<tr>
											<td>
												<label for="ident-<?php echo $n; ?>">Identifier:&nbsp;</label>
												<input type="text" size="26" id="ident-<?php echo $n; ?>" name="wpjsp-class-<?php echo $n; ?>" value="<?php echo $this->classes[$i]; ?>" />
											</td>
											<td>
												<label for="arrows-<?php echo $n; ?>">Scrollbar&nbsp;Arrows:&nbsp;#</label>
												<input type="text" size="6" maxlength="6" id="arrows-<?php echo $n; ?>" class="color-picker" name="wpjsp-arrows-<?php echo $n; ?>" value="<?php echo $this->arrows[$i]; ?>" />
											</td>
											<td>
												<label for="pos-<?php echo $n; ?>">Arrow&nbsp;Position:&nbsp;</label>
												<select id="pos-<?php echo $n; ?>" name="wpjsp-position-<?php echo $n; ?>">
													<option value=""<?php if ($this->position[$i]=='') {echo ' selected="selected"';} ?>></option>
													<option value="split"<?php if ($this->position[$i]=='split') {echo ' selected="selected"';} ?>>Split</option>
													<option value="before"<?php if ($this->position[$i]=='before') {echo ' selected="selected"';} ?>>Before</option>
													<option value="after"<?php if ($this->position[$i]=='after') {echo ' selected="selected"';} ?>>After</option>
													<option value="os"<?php if ($this->position[$i]=='os') {echo ' selected="selected"';} ?>>OS</option>
												</select>
											</td>
										</tr>
										<tr>
											<td>
												<label for="hw-<?php echo $n; ?>">HWidth:</label>
												<input type="text" size="2" maxlength="2" id="hw-<?php echo $n; ?>" class="numbers" name="wpjsp-hwidth-<?php echo $n; ?>" value="<?php echo $this->hwidth[$i]; ?>" /><label for="hw">px&nbsp;</label>
												<label for="vw-<?php echo $n; ?>">VWidth:</label>
												<input type="text" size="2" maxlength="2" id="vw-<?php echo $n; ?>" class="numbers" name="wpjsp-vwidth-<?php echo $n; ?>" value="<?php echo $this->vwidth[$i]; ?>" /><label for="vw">px</label>
											</td>
											<td>
												<label for="button-<?php echo $n; ?>">Scrollbar&nbsp;Button:&nbsp;#</label>
												<input type="text" size="6" maxlength="6" id="button-<?php echo $n; ?>" class="color-picker" name="wpjsp-button-<?php echo $n; ?>" value="<?php echo $this->button[$i]; ?>" />
											</td>
											<td>
												<input type="checkbox" id="left-<?php echo $n; ?>" name="wpjsp-left-<?php echo $n; ?>" <?php if (!($this->scrollleft[$i]=='')) {echo 'checked="checked" ';} ?>/>
												<label for="left-<?php echo $n; ?>">Move scrollbar to the left</label>
											</td>
										</tr>
										<tr>
											<td>
												<label for="hgutt-<?php echo $n; ?>">HGutter:&nbsp;</label>
												<input type="text" size="2" maxlength="2" id="hgutt-<?php echo $n; ?>" class="numbers" name="wpjsp-hgutter-<?php echo $n; ?>" value="<?php echo $this->hgutters[$i]; ?>" /><label>px&nbsp;</label>
												<label for="vgutt-<?php echo $n; ?>">VGutter:&nbsp;</label>
												<input type="text" size="2" maxlength="2" id="vgutt-<?php echo $n; ?>" class="numbers" name="wpjsp-vgutter-<?php echo $n; ?>" value="<?php echo $this->vgutters[$i]; ?>" /><label>px</label>
											</td>
											<td>
												<label for="pane-<?php echo $n; ?>">Scrollbar&nbsp;Pane:&nbsp;#</label>
												<input type="text" size="6" maxlength="6" id="pane-<?php echo $n; ?>" class="color-picker" name="wpjsp-pane-<?php echo $n; ?>" value="<?php echo $this->pane[$i]; ?>" />
											</td>
										</tr>
										<tr>
											<td>
												<label for="hcap-<?php echo $n; ?>">HCap:</label>
												<input type="text" size="2" maxlength="2" id="hcap-<?php echo $n; ?>" class="numbers" name="wpjsp-hcap-<?php echo $n; ?>" value="<?php echo $this->hcap[$i]; ?>" /><label>px&nbsp;</label>
												<label for="vcap-<?php echo $n; ?>">VCap:</label>
												<input type="text" size="2" maxlength="2" id="vcap-<?php echo $n; ?>" class="numbers" name="wpjsp-vcap-<?php echo $n; ?>" value="<?php echo $this->vcap[$i]; ?>" /><label>px</label>
											</td>
											<td>
												<label for="cap-<?php echo $n; ?>">Scrollbar&nbsp;Cap:&nbsp;#</label>
												<input type="text" size="6" maxlength="6" id="cap-<?php echo $n; ?>" class="color-picker" name="wpjsp-cap-<?php echo $n; ?>" value="<?php echo $this->cap[$i]; ?>" />
											</td>
										</tr>
									</tbody>
								</table>
							</div>
						<?php
						}
					?>
					<!--new jquery added scrollboxes after this line-->
					</div>
					<p class="submit">
						<input type="hidden" value="<?php echo wp_create_nonce('wpjsp-nonce'); ?>" name="wpjsp-nonce" />
						<input type="hidden" value="true" name="wpjsp" />
						<input type="submit" class="button-primary" tabindex="1" value="<?php _e('Save Changes') ?>" />
					</p>
					</form>
				</div>
			</div>
		<?php
		}
	}
}

// If WP jScrollPane is defined, run it!
if (class_exists('wp_jscrollpane')) {
	$wpjsp = new wp_jscrollpane();
}
?>